<script setup lang="ts">
import { ref, nextTick, onMounted } from 'vue'
import { useReportStockStore } from '@/stores/reportstock'
import { useCheckStockStore } from '@/stores/checkstock'
import { useStockReceiptStore } from '@/stores/stockreceipt'
import type { VForm } from 'vuetify/components'

const reportStore = useReportStockStore()
const checkStockStore = useCheckStockStore()
const stockReceiptStore = useStockReceiptStore()

const headers = [
  {
    title: 'Month',
    key: 'month',
    value: 'month'
  },
  {
    title: 'Name Stock',
    key: 'name',
    value: 'name'
  },
  {
    title: 'count_per_month',
    key: 'count_per_month',
    value: 'count_per_month'
  }
]

const headersStatus = [
  {
    title: 'ID',
    key: 'ROWID',
    value: 'ROWID'
  },
  {
    title: 'CheckStockDate',
    key: 'checkStockDate',
    value: 'checkStockDate'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Remain',
    key: 'remain',
    value: 'remain'
  },
  {
    title: 'Status',
    key: 'Status',
    value: 'Status'
  }
]

const headersCheckAVG = [
  {
    title: 'ID',
    key: 'RowID',
    value: 'RowID'
  },
  {
    title: 'Name',
    key: 'Name',
    value: 'Name'
  },
  {
    title: 'AvgTotal',
    key: 'avg_total',
    value: 'avg_total'
  },
  {
    title: 'TotalPrice',
    key: 'totalPrice',
    value: 'totalPrice'
  },
  {
    title: 'StatusAvg',
    key: 'Status_Avg',
    value: 'Status_Avg'
  }
]
const headersShowAVG = [
  {
    title: 'name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'total',
    key: 'total',
    value: 'total'
  },
  {
    title: 'avg_value',
    key: 'avg_value',
    value: 'avg_value'
  }
]
const itemsPerPage = ref<any>(8)
const page = ref(1)
const tab = ref('')
const loading = ref(false)
const SelectDatedialog = ref(false)
const ShowAVGdialog = ref(false)
const refForm = ref<VForm | null>(null)

function closeDialog() {
  SelectDatedialog.value = false
  nextTick(() => {
    checkStockStore.clearCheckStock()
  })
}

function CheckAvg() {
  stockReceiptStore.CheckAvg(stockReceiptStore.editedStockReceipt)
  ShowAVGdialog.value = false
}

function statusStock() {
  checkStockStore.showStatusStock(checkStockStore.editedCheckStock)
  SelectDatedialog.value = false
}

onMounted(() => {
  stockReceiptStore.editedStockReceipt.receiptDate = new Date()
  stockReceiptStore.CheckAvg(stockReceiptStore.editedStockReceipt)
  checkStockStore.editedCheckStock.checkStockDate = new Date()
  checkStockStore.showStatusStock(checkStockStore.editedCheckStock)
  stockReceiptStore.ShowAvg()
})
</script>

<template>
  <v-tabs v-model="tab" align-tabs="center" color="deep-purple-accent-4">
    <div>
      <v-tab style="color: black" :to="{ name: 'stock' }">Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'check-stock' }">Check Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'order-stock' }">Order Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'graph-stock' }">Graph</v-tab>
      <v-tab style="color: black" :to="{ name: 'report-stock' }">Report</v-tab>
    </div>
  </v-tabs>
  <h1 style="text-align: left" class="ml-5">ReportCheckStock</h1>
  <!-- <v-data-table
    v-model:page="page"
    :headers="headers"
    :items="reportStore.checkStocksData"
    :items-per-page="itemsPerPage"
  ></v-data-table> -->

  <v-btn style="background-color: sienna; width: 170px; height: 45px" class="mr-4">
    CheckStockStatus
    <v-dialog v-model="SelectDatedialog" activator="parent" width="auto" persistent>
      <v-sheet width="400" height="250" class="mx-auto">
        <v-card-title style="text-align: center" class="mt-5">Date</v-card-title>
        <v-form
          fast-fail
          @submit.prevent
          ref="refForm"
          style="margin-left: 10px; margin-right: 10px"
        >
          <v-text-field
            v-model="checkStockStore.editedCheckStock.checkStockDate"
            :readonly="loading"
            :rules="[(v) => !!v || 'required']"
            class="mb-2"
            label="Open Date"
            variant="outlined"
            type="month"
          ></v-text-field>
          <v-btn
            style="width: 150px; height: 50px"
            variant="flat"
            @click="SelectDatedialog = false"
            class="ms-5"
            color="red"
            >Cancel</v-btn
          >
          <v-btn
            style="width: 150px; height: 50px"
            variant="flat"
            @click="statusStock()"
            class="ms-10"
            color="success"
            >Save</v-btn
          >
        </v-form>
      </v-sheet>
    </v-dialog>
  </v-btn>
  <v-data-table
    v-model:page="page"
    :headers="headersStatus"
    :items="checkStockStore.checkStocksData"
    :items-per-page="itemsPerPage"
  ></v-data-table>
  <v-btn style="background-color: sienna; width: 170px; height: 45px" class="mr-4">
    ShowAVG
    <v-dialog v-model="ShowAVGdialog" activator="parent" width="auto" persistent>
      <v-sheet width="400" height="250" class="mx-auto">
        <v-card-title style="text-align: center" class="mt-5">Date</v-card-title>
        <v-form
          fast-fail
          @submit.prevent
          ref="refForm"
          style="margin-left: 10px; margin-right: 10px"
        >
          <v-text-field
            v-model="stockReceiptStore.editedStockReceipt.receiptDate"
            :readonly="loading"
            :rules="[(v) => !!v || 'required']"
            class="mb-2"
            label="Open Date"
            variant="outlined"
            type="month"
          ></v-text-field>
          <v-btn
            style="width: 150px; height: 50px"
            variant="flat"
            @click="ShowAVGdialog = false"
            class="ms-5"
            color="red"
            >Cancel</v-btn
          >
          <v-btn
            style="width: 150px; height: 50px"
            variant="flat"
            @click="CheckAvg()"
            class="ms-10"
            color="success"
            >Save</v-btn
          >
        </v-form>
      </v-sheet>
    </v-dialog></v-btn
  >
  <v-data-table
    v-model:page="page"
    :headers="headersCheckAVG"
    :items="stockReceiptStore.stockReceiptsData"
    :items-per-page="itemsPerPage"
  ></v-data-table>
  <label style="font-size: large" class="ml-4">ShowAVG</label>
  <br />
  <v-data-table
    v-model:page="page"
    :headers="headersShowAVG"
    :items="stockReceiptStore.stockReceiptsDa"
    :items-per-page="itemsPerPage"
  ></v-data-table>
</template>

<style scoped>
.v-btn {
  width: 235px;
  height: 90px;
  color: white;
  font-family: 'Kanit';
}
* {
  font-family: 'Kanit';
}
.left-half {
  height: 100%;
  background-color: #f0f0f0;
}
.right-half {
  height: 100%;
  background-color: grey;
}
</style>
